import { ICreateData } from './typings';
import type { worker, Position } from 'monaco-editor';
import * as monaco from 'monaco-editor';
import { SchemaConfig } from 'graphql-language-service';
import { GraphQLWorkerCompletionItem } from './utils';
import type { DocumentNode } from 'graphql';
export declare type MonacoCompletionItem = monaco.languages.CompletionItem & {
    isDeprecated?: boolean;
    deprecationReason?: string | null;
};
export declare class GraphQLWorker {
    private _ctx;
    private _languageService;
    private _formattingOptions;
    private _diagnosticSettings;
    constructor(ctx: worker.IWorkerContext, createData: ICreateData);
    doValidation(uri: string): Promise<globalThis.monaco.editor.IMarkerData[]>;
    doComplete(uri: string, position: Position): Promise<GraphQLWorkerCompletionItem[]>;
    doHover(uri: string, position: Position): Promise<{
        content: string | import("vscode-languageserver-types").MarkupContent | {
            language: string;
            value: string;
        } | import("vscode-languageserver-types").MarkedString[] | undefined;
        range: globalThis.monaco.IRange;
    } | null>;
    doGetVariablesJSONSchema(uri: string): Promise<unknown>;
    doFormat(uri: string): Promise<string | null>;
    doParse(text: string): Promise<DocumentNode>;
    private _getTextModel;
    doUpdateSchema(schema: SchemaConfig): void;
    doUpdateSchemas(schemas: SchemaConfig[]): Promise<void>;
}
declare const _default: {
    GraphQLWorker: typeof GraphQLWorker;
};
export default _default;
export declare function create(ctx: worker.IWorkerContext, createData: ICreateData): GraphQLWorker;
//# sourceMappingURL=GraphQLWorker.d.ts.map